/*	A routine to initialize the Vtype list "types"
	It must be added to for every new type added, by adding a call
on XXXdefine() where XXX is the prefix of the fun XXXdefine in the file
of functions for the new type.
	The routine also sets some global geometric constants.
	*/

#define NOTGLOB 1
#include "glob.c"

void	reals_define (Sw typindx);
void	mults_define (Sw typindx);
/*jj
void	vonm_define (Sw typindx);
*/


void dotypes ()
{
/*	Set the number of attribute types  */
	Ntypes = 4;

/*	Set constants  */
	pi = 4.0 * atan (1.0);
	hlg2pi = 0.5 * log (2.0 * pi);
	twoonpi = 2.0 / pi;
	pion2 = 0.5 * pi;
	bit = log (2.0);
	bit2 = 2.0 * bit;
	hlg2 = 0.5 * log (2.0);

/*	Make the 'types' vector  */
	types = (Vtype*) malloc (Ntypes * sizeof (Vtype));

	reals_define (0);
	mults_define (1);
/*jjj
	vonm_define (3);
*/

	return;
}
