/*	---------------------  MAIN FILE -----------------  */
#define NOTGLOB
#define MAIN 1
#include "glob.c"

FILE *yxw, *prepf;
#define Log fprintf(yxw,"%s ",keyw[skk]);fprintf(yxw,
#define EL );fprintf(yxw,"\n");fflush(yxw);
char sparam[80];
Sw intparam;
void showpoplnnames();
void showsamplenames();

/*	---------------------  menu  ---------------------------  */
/*	To read a command word and return an integer code for it  */

#define MNkey 50
static char const *keyw[MNkey] =	{
	"stop",
	"doall",
	"rmrep",
	"kclass",
	"ksons",
	"prclass",
	"adjust",
	"assign",
	"splitleaf",
	"combine",
	"help",
	"copypop",
	"kpop",
	"pickpop",
	"sum",
	"sto",
	"file",
	"readsamp",
	"flatten",
	"rprep",
	"samps",
	"tree",
	"zzzzzzzzzz",
	"zzzzzzzzzz",
	"zzzzzzzzzz",
	"prep",
	"ranclass",
	"save",
	"rsave",
	"nosubs",
	"zzzzzzzzzz",
	"zzzzzzzzzz",
	"zzzzzzzzzz",
	"pops",
	"crosstab",
	"mrep",
	"thing",
	"trep",
	"select",
	"zzzzzzzzzzzz" };

static Sw actk [MNkey], nkey, skk, nvkey;

static char const *prmt[] = {
	"stop stops both sprompt and cnob",
	"doall <N> does N steps of top-down re-estimation and assignment",

"rmrep <F> reads file F, which must have the format of a .mrep file\n\
  (see mrep) for the current sample. Work is replaced by a model built from\n\
  classes defined by the membership. Not all things in the sample need appear\n\
  in the members file. The .mrep suffix need not be included in F.",

"kclass <S> kills class serial S.  Subclasses also die.",

"ksons <S> kills all sons, grandsons etc. of class serial S. S becomes leaf",

"prclass <S, N> prints properties of class S. If N > 0, prints parameters\n\
   If S = -1, prints pop and all leaves.  If S = -2, includes subs, combine.\n\
   To print a sub of serial S, write as Sa or Sb",

"adjust controls which aspects of a population model will be changed.\n\
  Follow it with one or more characters from:\n\
   'a'll, 's'cores, 't'ree, 'p'arams, each followed by '+' or '-'\n\
  to turn adjustment on or off. Thus \"adjust t-p+\" disables tree structure\n\
  adjustment and enables class parameter adjustment.",

"assign <c> controls how things are assigned to classes. The character c\n\
  should be one of 'p'artial, 'm'ost_likely or 'r'andom. Default is 'p'.",

"splitleaf <S>, if class S is a leaf, replaces S by its subclasses.",

"combine <S1><S2> combines leaves S1, S2 into a single leaf class.",

"help <command> gives some details of the command. help <\"help\"> lists all",

"copypop <P> copies the \"work\" model to a new model named P",

"kpop <P> destroys a popln model. P must be the popln index or FULL name",

"pickpop <P> copies popln P to \"work\".  P = popln index or FULL name",

"sum  prints a summary of control settings and the classes.",

"To stop, please use the full word \"stop\".",

"file <F> switches command input to file name F. Command input will return\n\
  to keyboard at end of F or error, unless F contains a \"file\" command.\n\
  F may contain a file command with its own name, returning to the start of F.",

"readsamp <F> reads in a new sample from file F. Sample must use a Vset\n\
  already loaded.",

"flatten splits all leaves which have subclasses.",

"rprep <F> reads and stores a popln model from a '.prep' type file F.prep",

"samps lists the known samples.",

"tree prints a table of inter-leaf similarities using a pseudo-\n\
  Bhattacharyya Coefficient.",

"unused",

"unused",

"unused",

"prep <P> records model P on a file. Usually, the filename is P.prep but\n\
  if P is 'BST_...', filename is 'BSTP...' and the model is recorded with the\n\
   modified name. ALSO if P is 'work', prep requires an extra parameter as\n\
   new model name. 'prep work <Q>' records work with name Q in file Q.prep.",

"ranclass <N> destroys the current model and inserts N random leaves",

"save <P> records model P on a file. Usually, the filename is P.save but\n\
  if P is 'BST_...', filename is 'BSTP...' and the model is recorded with the\n\
   modified name. ALSO if P is 'work', save requires an extra parameter as\n\
   new model name. 'save work <Q>' records work with name Q in file Q.save.",

"rsave <F> reads a model from file named F.save, as saved by 'save'.",

"nosubs <N> kills and prevents birth of subclasses if N > 0",

"unused",

"unused",

"unused",

"pops lists the defined models.",

"crosstab <P> shows the overlap between the leaves of work and the leaves of\n\
   model P. The overlap is shown\n\
  as a permillage of the number of active things, in a cross-tabulation table.\n\
  A table entry for leaf serial Sw of work and leaf serial Sp of P shows the\n\
  permillage of all active things which are in both leaves. Crosstab <work> is\n\
  also meaningful. Here, an entry for leaves S1, S2 shows the permillage of\n\
  thing which are partially assigned to both classes.",

"mrep <F> writes a member report on file F.mrep. For each leaf, it lists\n\
   those things which most probably belong to the leaf",

"thing <N> finds the sample thing with identifier N.",

"trep <F> writes a thing report on file F. For each thing, lists up to 5\n\
  classes which may contain the thing, in order of decreasing probability.\n\
  The probability of each class is shown as a percentage (max 99, min 1).",

"select <S> first copies the current work model to a model called\n\
   OldWork, replaces the current sample by sample <S> where S is either name\n\
   or index, then sets work to the BST_ model for the sample, or, if none is\n\
   known, sets work to a one-leaf model of the sample. Leaves all adjust off.",

" " };

Sw poss[MNkey];

Sw menu (cnl)
	Sw cnl;
{
	char inp[80];

	Sw i,j,k, nposs;

	k = 0;
	i = readalf (inp, cnl);
	if (i == 2)	{
		printf("%s\n Enter command string:\n", prmt[10]);
		i = readalf (inp, 1);
		}
	if (i) return (-1);

/*	Try to identify possible keywords  */
	for (i = 0; i < nvkey; i++)   poss[i] = 1;
	nposs = i;
	for (; i < MNkey; i++) poss[i] = 0;
	for (j = 0; inp[j] != '\0'; j++)	{
		for (i = 0; i < nvkey; i++)	{
			if (poss[i])	{
				/* (We know j <= strlen(keyw[i]) because poss[i]
				 * would already be cleared if we'd encountered
				 * a '\0' at an earlier value of j.) */
				if (inp[j] != keyw[i][j])
					{poss[i] = 0; nposs--;}
				else k = i;
				}
			}
		}

	if (nposs <= 0)  {
		printf ("Unknown command '%s'\n", inp);
		return (-1);
		}
	if (nposs > 1)	{
	/*	Could have an exact match  */
		for (k = 0; k < nvkey; k++)	{
			if (poss[k] && (! keyw[k][j])) goto finish;
			}
		printf ("Ambiguous command\n");
		for (i = 0; i < nvkey; i++)  {
			if (poss[i]) printf(" %s?", keyw[i]);
			}
		printf ("\n");  return (-1);
		}
finish:
	skk = k;
	return (actk[k]);

	printf("Termination of source\n");
	return (0);
}


/*	-----------------  readserial -------------------------   */
/*	To get a class serial parameter for an action  */
/*	Returns the class ID or -3 for failure. Prints string if needed */
/*	If input serial is -1 or -2, returns -1 or -2  */
Sw readserial (prm)
	Sw prm;
{
	Sw n, k, nn;

	n = readint (&nn, 0);
	if (n == 2) {
		printf ("The serial of a subclass is the serial of its dad\
\nfollowed without space by 'a' or 'b', e.g. 12a\n");
		printf ("%s\n Enter class serial or x to abort\n", prmt[prm]);
		n = readint (&nn, 1);
		}
	if (n) return (-3);
	if ((nn == -1) || (nn == -2)) return (nn);
	nn *= 4;
	if (terminator == 'a') { nn += 1;  goto subserial; }
	if (terminator == 'b') { nn += 2;  goto subserial; }
	goto subdone;
subserial:	/* dispose of the terminator */
	ctx.buffer->nch ++;
subdone:
	k = s2id (nn);
	return (k);
}


/*	----------------------  readanint -----------------------------  */
/*	To read an integer action parameter. Returns -1 if error  */
Sw readanint (kk)
	Sw kk;
{
	Sw n, nn;

	n = readint (&nn, 0);
	if (n == 2) {
		printf ("%s\n Enter integer parameter N\n", prmt[kk]);
		n = readint (&nn, 1);
		}
	if (n) return (-1);
	return (nn);
}


/*	-------------------- readareal ----------------------------  */
/*	To read a real action parameter. Returns -1 if error, else 0  */
Sw readareal (kk, rea)
	Sw kk;   Sf *rea;
{
	Sf newv;  Sw n;

	n = readdf (&newv, 0);
	if (n == 2)	{
	  printf("%s\n Enter real parameter V or 'a' to abort.\n", prmt[kk]);
		n = readdf (&newv, 1);
		}
	if (n) return (-1);
	*rea = newv;  return (0);
}

/*	------------------- readsparam ---------------------------  */
/*	To read a string parameter. -1 if error  */
Sw readsparam (kk)
	Sw kk;
{
	Sw n;
	n = readalf (sparam, 0);
	if (n == 2)	{
		printf ("%s\n Enter string of characters\n", prmt[kk]);
		n = readalf (sparam, 1);
		}
	if (n) n = -1;
	return (n);
}


/*	---------------------  suffix  -----------------------  */
/*	if jj, appends .suff to sparam if not present. If not jj,
	deletes .suff from sparam if present. suff must have 4 chars. */
void suffix (jj, suff)
	Sw jj;  char *suff;
{
	Sw ll, lm, nos;

	ll = 0;  while (sparam[ll]) ll++;
	if (ll < 6) nos = 1;
	else {
		lm = ll - 5;
		if (sparam [lm] != '.') nos = 1;
		else nos = strcmp (sparam+lm+1, suff);
		}

	if (jj)  {	/*  Want suffix  */
		if (nos)	{
			sparam[ll] = '.';
			strcpy (sparam+ll+1, suff);
			}
		}
	else   {  /* Don't want suffix  */
		if (! nos) sparam [lm] = 0;
		}
	return;
}


/*	------------------  readachar  ------------------------  */
/*	To read one non-blank character  */
Sw readachar (kk)
	Sw kk;
{
	Sw i, nl;

	nl = 0;
next:
	i = readch (nl);
	switch (i)	{
case ' ':
case '\t':  goto next;
case 2 :
	printf ("%s\n Enter character:\n", prmt[kk]);
	nl = 1;  goto next;
		}
	return (i);
}


/*	-------------------- readintname -----------------------   */
/*	Reads a pos integer to intparam or name to sparam. Returns -1 if
	error. Leaves sparam = 0 if integer found  */
Sw readintname (kk, jj)
	Sw kk, jj;
{
	Sw n, i, nn, j;
	intparam = -1;
	n = readalf (sparam, 0);
	if (n == 2)     {
		printf ("%s\n Enter name string or integer index\n",prmt[kk]);
		switch (jj)	{
	case 1:
		showpoplnnames ();  break;
	case 2:
		showsamplenames ();  break;
			}
		n = readalf (sparam, 1);
		}
	if (n) return (-1);
	nn = 0;
/*	Scan sparam for an integer  */
	i = 0;
nextch:
	j = sparam[i++];
	if ((j >= '0') && (j <= '9'))	{
		nn = 10 * nn + j - '0';
		goto nextch;
		}
	if ((j == 0) || (j == ' ') || (j == '\t')) goto gotnum;
/*	Not a number.  */
	goto fine;

gotnum:
	sparam[0] = 0;  intparam = nn;
fine:	return (0);
}


/*	--------------------  showpoplnnames  ---------------------  */
void showpoplnnames()
{
	Sw i;
	printf ("The defined models are:\n");
	for (i = 0; i < Maxpoplns; i++)	{
		if (poplns [i])	{
			printf ("%2d %s", i+1, poplns[i]->name);
			if (poplns[i]->nc)
				printf (" Sample %s", poplns[i]->samplename);
			else printf (" (unattached)");
			printf ("\n");
			}
		}
	printf ("Also, the pseudonym \"BST_\" can be used for the best\n\
model for the current sample\n");
	return;
}


/*      ----------------------  showsamplenames  -----------------  */
void showsamplenames()
{
        Sw k;
        printf ("Loaded samples:\n");
        for (k = 0; k < Maxsamples; k++)        {
                if (samples[k]) {
                        printf ("%2d:  %s\n", k+1, samples[k]->name);
                        }
                }
        return;
}


/*	--------------------  readpopid  ------------------------  */
/*	To read a popln index (+1) or name and return index    */
Sw readpopid (kk)
	Sw kk;
{
	Sw n, nn;

	n = readintname (kk, 1);
	if (n) return (n);
	if (intparam < 0) goto tryforname;
	nn = intparam - 1;
	if ((nn < 0) || (nn >= Maxpoplns)) goto invalidindex;
	if (poplns[nn] && (poplns[nn]->id == nn)) return (nn);
invalidindex:
	printf ("%d is not a valid popln index\n", intparam); return (-1);

tryforname:
	nn = pname2id (sparam);
	if (nn < 0) printf ("%s is not a model name\n", sparam);
	return (nn);
}


/*      --------------------  readsampid  ------------------------  */
/*      To read a sample index (+1) or name and return index    */
Sw readsampid (kk)
        Sw kk;
{
        Sw n, nn;

        n = readintname (kk, 2);
        if (n) return (n);
        if (intparam < 0) goto tryforname;
        nn = intparam - 1;
        if ((nn < 0) || (nn >= Maxsamples)) goto invalidindex;
        if (samples[nn] && (samples[nn]->id == nn)) return (nn);
invalidindex:
        printf ("%d is not a valid sample index\n", intparam); return (-1);

tryforname:
        nn = sname2id (sparam, 1);
        if (nn < 0) printf ("%s is not a sample name\n", sparam);
        return (nn);
}


/*	---------------------  main  ---------------------------  */
extern char *malloc_options;
Sw main ()
{
	Sw k, kk, k1, k2;
	Sw i, j, n, nn, cspace;
	Context oldctx;

	rseed = 1234567;
	defaulttune ();
	cycle = 0;

/*	A section to sort the keywords into alphabetic order, and set
actk[] to hold their original order indexes   */
/*	First, fill out keyw[] with z-strings   */
	for (i = 0; strcmp (keyw[i], "zzzzzzzzzzzz");  i++)       {
		actk[i] = i;
		}
	nkey = i;
	for (; i < MNkey; i++)	{
		keyw[i] = "zzzzzzzzzzzz";  actk[i] = 999;
		}
/*	Now bubble-sort the first nkey entries   */
	for (i = (nkey-1); i > 0; i--)	{
		for (j = 0; j < i; j++)	{
			if (strcmp (keyw[j], keyw[j+1]) > 0)	{
				char const *chp;
				chp = keyw[j]; keyw[j] = keyw[j+1];
				keyw[j+1] = chp;
				n = actk[j]; actk[j] = actk[j+1];
				actk[j+1] = n;
				}
			}
		}
/*	Count valid ones (not 10 z-s)	*/
	nvkey = 0;
	for (i = 0; i < nkey; i++)	{
		if (strcmp (keyw[i], "zzzzzzzzzz"))   nvkey ++;
		}
	prepf = fopen ("Snob.Menu", "w");
	fprintf (prepf,"\t\tVanilla Snob Command Digest\n\n");
	for (i = 0; i < nkey; i++)      {
		if (strcmp (keyw[i], "zzzzzzzzzz"))  {
			fprintf (prepf, "\t..........\n%s\n", prmt [actk[i]]);
			}
		}
	fclose (prepf);

	fix = dfix = Partial;
	dcontrol = control = AdjAll;
/*	Clear vectors of pointers to Poplns, Samples  */
	for (k = 0; k < Maxpoplns; k++) poplns[k] = 0;
	for (k = 0; k < Maxsamples; k++) samples[k] = 0;
	for (k = 0; k < Maxvsets; k++) vsets[k] = 0;
	dotypes();

/*	Set source to commsbuf and initialize  */
	source = &commsbuf;  ctx.buffer = source;
	source->cfile = 0;  source->nch = 0;  source->inl[0] = '\n';
	heard = usestdin = 0;

/*ddd
printf("Enter var and state to watch (kiv, kz)\n");
ddd*/

/*	Open a log file   */
	yxw = fopen ("run.log", "w");

	kk = readvset ();
	printf ("Readvset returns %d\n", kk);
	if (kk < 0) exit (2);
	else vst = ctx.vset = vsets[kk];

	printf ("Enter sample file name:\n");
	if (readalf (sparam, 1) < 0)	{
		printf ("Cannot read sample file name\n");  goto error;
/*		FIXME: gcc -Wuninitialized correctly identifies that cspace
doesn't get initialized if we jump to error. */
		}
	suffix (1, "samp");
	k = readsample (sparam);
	printf ("Readsample returns %d\n", k);
	cspace = repspace (1);
	kk = firstpop ();
	flp();  printf ("Firstpop returns %d\n", kk);
	cspace = repspace (1);

	trapcnt = 0;
#ifdef TRAP
	printf ("Enter trap class, age; or -1 for notrap: ");
	scanf ("%d", &trapkk);  trapcnt = 0;
	if (trapkk >= 0) scanf ("%d", &trapage);
#endif
	printclass (root,0, stdout);
error:
	printf("??? line %6d\n", source->line);
	newline();
	if (source->cfile) revert (0);
loop:
	k = pname2id ("TrialPop");
	if (k >= 0) killpop (k);
	flp();
	kk = repspace (0);  if (kk != cspace) cspace = repspace (1);
	if (heard)	{
		revert (1);  heard = 0;  }
	if (! ctx.popln) {  kk = 13;  goto pickapop; }
	fix = dfix;  control = dcontrol;
	tidy (1);
	trackbest(1);
	setpop();
	if (! source->cfile)	{
		flp();
		printf (">>  Cycle %8d  Pop %2d  %4d leaves  Cost %8.1f\n",
			cycle, pop->id+1, pop->nleaf, pop->cost);
		printf (">>  Sample %s\n", samp->name);
		printf (">>  Adjust ");
		printf ("%c", (control&AdjPr) ? 'P' : '-');
		printf ("%c", (control&AdjTr) ? 'T' : '-');
		printf ("  Assign ");
		if (fix == Partial) printf ("P");
		else if (fix == Most_likely) printf ("M");
		else if (fix == Random) printf ("R");
		if (nosubs) printf ("  NOSUBS");
		printf ("\n# ");
		fflush (stdout);
		}
	if ((source->nch) || (source->inl[0] == '\n')) {
		if (newline()) goto error;
		}
	kk = menu(1);
	if (kk < 0) goto error;
	switch (kk)	{
case 0:		fprintf(yxw,"\n"); fclose(yxw); exit (2);
case 1:		/* doall */
	nn = readanint (kk);
	if (nn < 0) goto error;
	Log "%d", nn EL
	k = doall (nn);
	if (k >= 0) { flp(); printf("Doall ends after %d cycles\n", k); }
	goto loop;
case 2:		/* rmrep */
	if (readsparam (kk) < 0) goto error;
	suffix (1, "mrep");
	k = rmrep (sparam);
	if (k) goto error;
	suffix (0, "mrep");
	Log "%s", sparam EL
	goto loop;
case 3:		/* kclass */
	k = readserial (kk);
	if (k == root)	{
		printf("Won't kill Root\n");  goto loop;
		}
	if (k < 0) goto error;
	Log "%s", sers(pop->classes[k]) EL
	pop->classes[k]->cnt = 0.0;
	goto loop;
case 4:		/* ksons */
	k = readserial (kk);
	if (k < 0) goto error;
	Log "%s", sers(pop->classes[k]) EL
	killsons (k);
	goto loop;
case 5:		/* prclass */
	k = readserial (kk);
	if (k < -2) goto error;
	i = readanint (kk);
	if (i < 0) goto error;
	if (k < 0) {
		Log "%d  %1d", k, i EL
		}
	else	{
		Log "%s  %d", sers(pop->classes[k]), i EL
		}
	printclass (k, i, stdout);  goto loop;
case 6:		/*	adjust  */
	k = readsparam (kk);
	if (k < 0) goto error;
	i = 0;  n = nn = 0;
adjchar1:
	k = sparam [i++];
	switch (k)	{
	case 0:		goto adjflagsin;
	case 'a' :	j = AdjAll;  goto adjchar2;
	case 't' :	j = AdjTr;   goto adjchar2;
	case 'p' :	j = AdjPr;   goto adjchar2;
		}
	goto error;

adjchar2:
	k = sparam [i++];
	switch (k)	{
	case '+':  n |= j;  goto adjchar1;
	case '-': nn |= j;  goto adjchar1;
		}
	goto error;
adjflagsin:
	Log "%s", sparam EL
	nn = AdjAll - nn;
	control = dcontrol = (dcontrol & nn) | n;
	goto loop;
case 7:		/*  assign  */
	k = readachar (kk);
	switch (k) {
	case 'p':  dfix = Partial;  goto assignok;;
	case 'r':  dfix = Random;  goto assignok;;
	case 'm':  dfix = Most_likely; goto assignok;;
		}
	goto error;
assignok:	Log "%c",k EL  goto loop;
case 8:		/* splitleaf */
	k = readserial (kk);
	if (k < 0) goto error;
	if (pop->classes[k]->type != Leaf)  {
		printf ("Class %s is not a leaf\n", sers(pop->classes[k]));
		goto loop;  }
	Log "%s", sers(pop->classes[k]) EL
	if (splitleaf(k)) printf("Cannot split class%s\n", sers(pop->classes[k]));
	goto loop;

case 9:		/* combine */
	k1 = readserial (kk);  if (k1 < 0) goto error;
	k2 = readserial (kk);  if (k2 < 0) goto error;
	if (combine (k1, k2)) goto error;
	Log "%s  %s", sers(pop->classes[k1]), sers(pop->classes[k2]) EL
	goto loop;

case 10:	/* help */
	k = menu (0);
	if (k < 0) goto error;
	if (k == kk) goto listall;
	printf ("%s\n", prmt[k]);  goto loop;

listall:
/*	This bit lists all the command words, 5 per line	*/
/*	Keywords of 10 z-s are omitted, so first I count valid ones  */
	n = (nvkey + 4) / 5;
	for (k = 0; k < n; k++)	{
		for (j = 0; j < 5; j++)		{
			i = j * n + k;
			if (i >= nvkey) goto endof5;
			printf ("%-15s", keyw[i]);
		endof5:	;
			}
		printf ("\n");
		}
	goto loop;
case 11:	/* copypop */
	j = readsparam (kk); if (j < 0) goto error;
	if (! strcmp(sparam, "work"))	{
		printf ("Donot copy work into work!\n");
		goto error;	}
	for (j = 0; j < 4; j++)	{
		if (sparam[j] != "BST_"[j]) goto ok11;  }
	printf ("Please donot use a popln name beginning BST_\n");
	goto error;
ok11:
	Log "%s", sparam EL
	i = copypop (pop->id, sparam);
	if (i < 0) goto error;
	printf ("Index%3d = popln %s\n", i+1, sparam);
	control = dcontrol;  fix = dfix;
	goto loop;
case 12:	/*  kpop */
	k = readpopid (kk);
	if (k < 0) goto error;
	if (! strcmp (poplns[k]->name, "work"))	{
		printf ("Don't kill work.\n");
		goto error;
		}
	Log "%s", poplns[k]->name EL
	killpop (k);
	goto loop;
case 13:	/* pickpop */
	goto pickapop;
case 14:	/* sum */
	printtree();  goto loop;
case 15:	/* sto */
	printf ("%s\n", prmt[kk]);  goto loop;
case 16:	/* file */
	k = readsparam (kk);  if (k < 0) goto error;
	if (source->cfile) bufclose ();
	strcpy (cfilebuf.cname, sparam);  source = &cfilebuf;
	ctx.buffer = source;
	if (bufopen()) {
		printf ("Cant open file %s\n", sparam);  goto error; }
	goto loop;
case 17:         /* readsamp  */
        if (readsparam (kk) < 0) goto error;
        cmcpy (&oldctx, &ctx, sizeof (Context));
	suffix (1, "samp");
        k = readsample (sparam);
        cmcpy (&ctx, &oldctx, sizeof (Context));
        if (k < 0) goto error;
        printf ("Sample %s index%2d from file %s\n",
                samples[k]->name, k+1, sparam);
	suffix (0, "samp");
        Log "%s", sparam EL
        goto loop;
case 18:	/*  flatten  */
	Log " " EL
	flatten ();
	goto loop;

case 19:	/* rprep */
	if (readsparam (kk) < 0) goto error;
	suffix (1, "prep");
	k = rprep (sparam);
	if (k < 0)	{
		printf ("Restore failed\n");  goto error;
		}
	suffix (0, "prep");
	Log "%s", sparam EL
	printf ("Model %s Index%3d\n", poplns[k]->name, k+1);
	goto loop;

case 20:        /*  samps  */
        showsamplenames ();
        goto loop;

case 21:	/*  tree  */
	k = htree();
	if (k < 0)	{
		printf ("Tree requires a model with attached sample to be\
 presnt\n");
		goto error;
		}
	Log " " EL
	goto loop;

case 25:	/*  prep  */
	cmcpy (&oldctx, &ctx, sizeof (Context));
	k = readpopid (kk);
	if (k < 0) goto error;
	pop = poplns[k];
	if (! strcmp (pop->name, "work"))	{
		if (readsparam (kk) < 0) goto error;
		strcpy (pop->name, sparam);
		j = 1;
		}
	else	{
		j = -1;
		for (n = 0; n < 4; n++)  {
			if (pop->name[n] != "BST_"[n]) j = 0;
			}
		}
	if (j == -1) {
		pop->name[3] = 'P';
	printf("Model BST_... will be saved as 'BSTP...'\n");
		}
	ctx.popln = pop;
	strcpy (sparam, pop->name);
	suffix (1, "prep");
	prepf = fopen (sparam, "w");
	fprintf (prepf, "%s\n", saveheading);
	fprintf (prepf, "%s\n", pop->name);
	fprintf (prepf, "VariableSet #%s\n", pop->vstname);
	fprintf (prepf, "Sample #%s\n", pop->samplename);
	fprintf (prepf, "Samplesize #%8d  Cost #%10.1f\n",
		pop->samplesize, pop->cost);
	fprintf (prepf, "#%4d  leaves\n", pop->nleaf);
	printclass (-1, 1, prepf);
	fclose (prepf);
	suffix (0, "prep");
	pop = poplns[k];
	if (j == -1) pop->name[3] = '_';
	if (j == 1)	{
		strcpy (pop->name, "work");
		Log "work %s", sparam EL
		}
	else	{
		Log "%s", pop->name EL
		}
	cmcpy (&ctx, &oldctx, sizeof (Context));
	goto loop;

case 26:	/*  ranclass  */
	nn = readanint (kk);
	if (nn < 1) goto error;
	Log "%d", nn EL
	ranclass (nn);
	goto loop;

case 27:	/*  save */
	k = readpopid (kk);
	if (k < 0) goto error;
	pop = poplns [k];
	if (! strcmp (pop->name, "work"))	{
		if (readsparam (kk) < 0) goto error;
		strcpy (pop->name, sparam);
		j = 1;
		}
	else	{
		j = -1;
		for (n = 0; n < 4; n++)  {
			if (pop->name[n] != "BST_"[n]) j = 0;
			}
		}
	if (j == -1) {
		pop->name[3] = 'P';
	printf("Model BST_... will be saved as 'BSTP...'\n");
		}
	strcpy (sparam, pop->name);
	suffix (1, "save");
	i = savepop (k, sparam);
	if (i < 0)  { printf("Savepop failed\n"); goto error; }
	suffix (0, "save");
	pop = poplns[k];
	if (j == -1) pop->name[3] = '_';
	if (j == 1)	{
		strcpy (pop->name, "work");
		Log "work %s", sparam EL
		}
	else	{
		Log "%s", pop->name EL
		}
	goto loop;

case 28:	/*  rsave */
	if (readsparam (kk) < 0) goto error;
	suffix (1, "save");
	k = rsave (sparam);
	if (k < 0) {printf("Restorepop failed\n"); goto error; }
	suffix (0, "save");
	Log "%s", sparam EL
	printf ("Model %s Index%3d\n", poplns[k]->name, k+1);
	goto loop;

case 29:	/* nosubs */
	nn = readanint (kk);
	if (nn < 0) goto error;
	if (nn) nosubs = 1;  else nosubs = 0;
	Log "%d", nosubs EL
	goto loop;

case 33:	/*  pops  */
	showpoplnnames ();
	goto loop;

case 34:	/*  crosstab  */
	k = readpopid (kk);
	if (k < 0) goto error;
	crosstab (k);
	Log "%s", poplns[k]->name EL
	goto loop;

case 35:	/* mrep */
	if (readsparam (kk) < 0) goto error;
	suffix (1, "mrep");
	memlist (sparam);
	suffix (0, "mrep");
	Log "%s", sparam EL
	goto loop;

case 36:	/* thing */
	nn = readanint (kk);
	if (nn < 0) goto error;
	Log "%d", nn EL
	kk = id2ind (nn);
	printf ("Thing%8d  at index%8d\n", nn, kk);
	goto loop;

case 37:	/* trep */
	if (readsparam (kk) < 0) goto error;
	suffix (1, "trep");
	thinglist (sparam);
	suffix (0, "trep");
	Log "%s", sparam EL
	goto loop;

case 38:	/* select */
	k = readsampid (kk);
	if (k < 0) goto error;
	if (ctx.sample == samples[k])	{
		printf ("Sample %s already selected\n", ctx.sample->name);
		goto loop;
		}
	printf ("Selecting sample %s\n", samples[k]->name);
	Log "%s", samples[k]->name EL
	i = copypop (pop->id, "OldWork");
	if (i < 0)	{
		printf ("Can't make OldWork copy of work\n");
		goto error;
		}
	if (ctx.popln) killpop (ctx.popln->id);
	pop = ctx.popln = 0;
	samp = ctx.sample = samples [k];
	strcpy (sparam, "BST_");  strcpy(sparam+4, samp->name);
	i = pname2id (sparam);
	if (i >= 0)	{
		k = loadpop (i);
		ctx.popln = pop = poplns [k];
		}
	else	{
		control = AdjPr;
		i = firstpop ();
		if (i < 0) {
			printf ("Cannot make first population for sample\n");
			goto error;
			}
		}
	dcontrol = control = 0;
	goto loop;
		};	/* End of kk switch  */

pickapop:
	i = readpopid (kk);  if (i < 0) goto error;
	if (! strcmp (poplns[i]->name, "work")) {
		if (ctx.popln && (ctx.popln->id == i))
			printf("Work already picked\n");
		else
			printf ("Switching context to existing 'work'");
		k = i; goto picked;  }
	k = loadpop (i);
picked:
	ctx.popln = pop = poplns [k];
	Log "%s", poplns[i]->name EL
	goto loop;
}
