#define BADMOVES 1
#define NOTGLOB 1
#include "glob.c"


typedef struct BadMovest  {
	Sw key;
	Sw when;
	} BadMove;

static BadMove baddy [BadSize];


/*	---------------  clearbadm  --------------------------------  */
/*	To clear the badmoves table  */
void clearbadm ()
{
	Sw i;
	for (i = 0; i < BadSize; i++) baddy[i].key = 0;
	return;
}

/*	-----------------  testbadm  -----------------------------  */
/*	To test a move for known recent fail  */
/*	Code 1 means combine, code 2 means kill  */
Sw testbadm (code, w1, w2)
	Sw code, w1, w2;
{
	Sw hi, key, bad, s1, s2;

	setpop ();
	s1 = w1;  s2 = w2;
	if ((code == 1) || (code == 3))  {
		if (w1 > w2)  { s1 = w2;  s2 = w1; }
		}
	else s1 = 0;
	key = hi = (((code << 13) + s1) << 13) + s2;
	if (hi < 0) hi = -1 - hi;
	hi = hi % BadSize;
	bad = 0;
	if (baddy[hi].key != key) goto done;
	if ((cycle - baddy[hi].when) > BadMem)	{
		baddy[hi].key = 0;  goto done;
		}
	
	bad = 1;
done:	return (bad);
}


/*	------------------  setbadm  -----------------------------   */
/*	To log a bad move  */
void setbadm (code, s1, s2)
	Sw code, s1, s2;
{
	Sw hi, key;

	if ((code == 1) || (code == 3))  {
		if (s1 > s2)  { hi = s2;  s2 = s1;  s1 = hi; }
		}
	else s1 = 0;
	key = hi = (((code << 13) + s1) << 13) + s2;
	setpop ();
	if (hi < 0) hi = -1 - hi;
	hi = hi % BadSize;
	baddy[hi].key = key;  baddy[hi].when = cycle;
	return;
}
